/*
EntryPoints

## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it's possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package entrypoints

import (
	"encoding/json"
)

// checks if the EntryPoint type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EntryPoint{}

// EntryPoint struct for EntryPoint
type EntryPoint struct {
	Type EntryPointType `json:"type"`
	// Base64 encoded image with qr code 
	Base64Image *string `json:"base64_image,omitempty"`
	Url string `json:"url"`
}

// NewEntryPoint instantiates a new EntryPoint object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEntryPoint(type_ EntryPointType, url string) *EntryPoint {
	this := EntryPoint{}
	this.Type = type_
	this.Url = url
	return &this
}

// NewEntryPointWithDefaults instantiates a new EntryPoint object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEntryPointWithDefaults() *EntryPoint {
	this := EntryPoint{}
	return &this
}

// GetType returns the Type field value
func (o *EntryPoint) GetType() EntryPointType {
	if o == nil {
		var ret EntryPointType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *EntryPoint) GetTypeOk() (*EntryPointType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *EntryPoint) SetType(v EntryPointType) {
	o.Type = v
}

// GetBase64Image returns the Base64Image field value if set, zero value otherwise.
func (o *EntryPoint) GetBase64Image() string {
	if o == nil || IsNil(o.Base64Image) {
		var ret string
		return ret
	}
	return *o.Base64Image
}

// GetBase64ImageOk returns a tuple with the Base64Image field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EntryPoint) GetBase64ImageOk() (*string, bool) {
	if o == nil || IsNil(o.Base64Image) {
		return nil, false
	}
	return o.Base64Image, true
}

// HasBase64Image returns a boolean if a field has been set.
func (o *EntryPoint) HasBase64Image() bool {
	if o != nil && !IsNil(o.Base64Image) {
		return true
	}

	return false
}

// SetBase64Image gets a reference to the given string and assigns it to the Base64Image field.
func (o *EntryPoint) SetBase64Image(v string) {
	o.Base64Image = &v
}

// GetUrl returns the Url field value
func (o *EntryPoint) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *EntryPoint) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *EntryPoint) SetUrl(v string) {
	o.Url = v
}

func (o EntryPoint) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EntryPoint) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.Base64Image) {
		toSerialize["base64_image"] = o.Base64Image
	}
	toSerialize["url"] = o.Url
	return toSerialize, nil
}

type NullableEntryPoint struct {
	value *EntryPoint
	isSet bool
}

func (v NullableEntryPoint) Get() *EntryPoint {
	return v.value
}

func (v *NullableEntryPoint) Set(val *EntryPoint) {
	v.value = val
	v.isSet = true
}

func (v NullableEntryPoint) IsSet() bool {
	return v.isSet
}

func (v *NullableEntryPoint) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEntryPoint(val *EntryPoint) *NullableEntryPoint {
	return &NullableEntryPoint{value: val, isSet: true}
}

func (v NullableEntryPoint) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEntryPoint) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


